﻿
Enumeration
  #Window
  
  #GadgetKartinka
  #SamaKartinka
  
  #File
  
  #Canvas
  #Canvas2
  #Vstavka
  #VstavkinaKartinka
  #Canvas3
  #VstavkinaKartinkaSega
EndEnumeration

Global *MemoryID ; указатель для памяти, в котором будет сидеть файл 01.bin

; массив с кодами цветов
Global Dim SegaSegmentColor.a(16)
; 0, 36, 72, 109, 145, 181, 219, 255
SegaSegmentColor(2)  =  36
SegaSegmentColor(4)  =  72
SegaSegmentColor(6)  = 109
SegaSegmentColor(8)  = 145
SegaSegmentColor(10) = 181
SegaSegmentColor(12) = 219
SegaSegmentColor(14) = 255

; создаем сложный массив с 4 колонками и 16 строчек в каждой. как Ексель таблица.
Structure colorstructure
  ; 17 а не 16 - потому что считается количество ячеек с 0. но мне для удобства хотелось бы с 1 считать.
  ; поэтому 17
  ColorNum.l[17] 
EndStructure
Global Dim PalNum.colorstructure(4)


; процедура для рисования тайла
Procedure RisuemTile(startx.u, starty.u, memory.l)
  
  ; счетчик сдвига в памяти
  k = 0
  
  ; расчет докуда крутить по Х и по У
  endx = startx + 7
  endy = starty + 7 
  
  ; сами циклы
  For y = starty To endy
    For x = startx To endx Step 2 ; перепрыгивать каждые 2
        
        ; читаем значение из памяти
        Number = PeekA(memory + k)
        
        ; раскладываем число на 2 пикселя. по 4 бита на пиксель
        first  = Number >> 4 ; знакомый сдвиг
        second = Number & $F ; новая херня - отсечение по маске.
        ; рисуем точки с нужными цветами
        Plot(x,     y, PalNum(2)\ColorNum[first])
        Plot(x + 1, y, PalNum(2)\ColorNum[second])
        
        ; сдвиг по памяти дальше
        k + 1
        
    Next
  Next  
  
EndProcedure


;{ тут магическая фигня для подбора цветов

; NearestColor module by Wilbert

; Latest updated : Jan 27, 2016

; Color distance formula based on:
; http://www.compuphase.com/cmetric.htm

; Dithering method:
; Sierra Lite

DeclareModule NearestColor
  
  Prototype ProtoProgressCallback(PercentProgress.i)
  
  Declare   CatchPalette(*MemoryAddress.Long, NumColors.i)
  Declare   CopyPalette(Array DestinationArray.l(1))
  Declare.i DitheredImage(Image.i, DitherLevel.a = 220, Brightness.b = 0, Contrast.b = 0, ProgressCallback.ProtoProgressCallback = 0)
  Declare.l FindNearest(Color.l)
  Declare.i PaletteColorCount()
  Declare   SetPalette(PaletteImage.i)
  
EndDeclareModule

Module NearestColor
  
  EnableASM
  ;EnableExplicit
  ;DisableDebugger
  
  Structure ColorScan
    l.l[524288]
  EndStructure
  
  Global ColorScan.ColorScan
  Global Dim IndexG.l(255)
  Global Dim Palette.l(1)
  
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
    Macro rdx : edx : EndMacro
  CompilerEndIf
  
  Procedure.i PaletteColorCount()
    ; Return amount of colors the palette contains
    ProcedureReturn ArraySize(Palette()) - 1
  EndProcedure
  
  Procedure CopyPalette(Array DestinationArray.l(1))
    ; Copy the current palette into a supplied array
    Protected.i cnt = ArraySize(Palette()) - 1
    ReDim DestinationArray(cnt - 1)
    CopyMemory(@Palette(1), @DestinationArray(0), cnt << 2)
  EndProcedure
  
  Procedure CatchPalette(*MemoryAddress.Long, NumColors.i)
    ; Catch a palette from memory
    Protected.i i, j = 1
    ReDim Palette(NumColors + 1)
    Palette(0) = 0 : Palette(NumColors + 1) = 0
    For i = 1 To NumColors
      Palette(i) = $ff000000 | *MemoryAddress\l
      *MemoryAddress + 4
    Next
    SortStructuredArray(Palette(), 0, 0, #PB_Unicode, 1, NumColors)
    For i = 0 To 255
      IndexG(i) = j
      While ((Palette(j) >> 8) & $ff) = i And j < NumColors
        j + 1
      Wend
      IndexG(i) = (IndexG(i) + j) >> 1
    Next
  EndProcedure
  
  Procedure SetPalette(PaletteImage.i)
    ; Set a palette from an image
    Protected.i i, j, b, x, y, cnt
    Protected.l c, c_
    If StartDrawing(ImageOutput(PaletteImage))
      FillMemory(@ColorScan, SizeOf(ColorScan))
      j = OutputHeight() - 1
      i = OutputWidth() - 1
      ; count all used colors
      For y = 0 To j
        For x = 0 To i
          c = Point(x, y)
          !mov eax, [p.v_c]
          !rol ax, 8
          !bswap eax
          !shr eax, 8
          lea rdx, [nearestcolor.v_ColorScan]
          bts [rdx], eax
          !jc nearestcolor.setpalette_cont0
          inc cnt
          !nearestcolor.setpalette_cont0:
        Next
      Next
      StopDrawing()
      ; redim palette with room at top and bottom for zero entry
      ReDim Palette(cnt + 1)
      Palette(0) = 0 : Palette(cnt + 1) = 0
      ; set palette sorted on G, R, B and index on G
      i = 0 : j = 1
      For y = 0 To 255
        IndexG(y) = j
        For x = 0 To 2047
          b = 0 : c_ = ColorScan\l[i]
          While c_
            shr c_, 1
            !jnc nearestcolor.setpalette_cont1          
            !mov eax, [p.v_i]
            !shl eax, 5
            !or eax, [p.v_b]
            !shl eax, 8
            !or eax, 0xff
            !bswap eax
            !rol ax, 8
            !mov [p.v_c], eax
            Palette(j) = c : j + 1
            !nearestcolor.setpalette_cont1:          
            b + 1
          Wend
          i + 1  
        Next
        IndexG(y) = (IndexG(y) + j) >> 1   
      Next
    EndIf  
  EndProcedure
  
  Macro M_FindNearest(i, st)
    !nearestcolor.findnearest#i#_loop: 
    !mov ecx, [p.v_c#i#]
    !test ecx, ecx
    !jz nearestcolor.findnearest#i#_cont2
    !movzx eax, byte [p.v_Color + 1]
    !movzx ecx, ch
    !sub eax, ecx
    !imul eax, eax
    !shl eax, 11
    !cmp eax, [p.v_bestd]
    !jnc nearestcolor.findnearest#i#_cont1
    !mov [p.v_d], eax
    !movzx eax, byte [p.v_Color]
    !movzx ecx, byte [p.v_c#i#]
    !lea edx, [eax + ecx]   ; edx = rsum
    !sub eax, ecx
    !imul eax, eax          ; eax = r*r
    !lea ecx, [edx + 0x400] ; ecx = $400 + rsum
    !imul eax, ecx          ; eax = ($400+rsum)*r*r
    !add [p.v_d], eax
    !movzx eax, byte [p.v_Color + 2]
    !movzx ecx, byte [p.v_c#i# + 2]
    !sub eax, ecx
    !imul eax, eax          ; eax = b*b
    !neg edx
    !add edx, 0x5fe         ; edx = $5fe - rsum
    !imul eax, edx          ; eax = ($5fe-rsum)*b*b
    !add eax, [p.v_d]
    !cmp eax, [p.v_bestd]
    !jnc nearestcolor.findnearest#i#_cont0
    !mov [p.v_bestd], eax
    !mov eax, [p.v_c#i#]
    !mov [p.v_c], eax
    !nearestcolor.findnearest#i#_cont0:
    mov rdx, *p#i
    add rdx, st
    mov *p#i, rdx
    mov eax, [rdx]
    !mov [p.v_c#i#], eax
    CompilerIf i = 1
      !jmp nearestcolor.findnearest0_loop
    CompilerElse
      !jmp nearestcolor.findnearest1_loop
    CompilerEndIf
    !nearestcolor.findnearest#i#_cont1:
    !mov dword [p.v_c#i#], 0
    !nearestcolor.findnearest#i#_cont2:
    CompilerIf i = 1
      !cmp dword [p.v_c0], 0
      !jnz nearestcolor.findnearest0_loop
    CompilerEndIf
  EndMacro
  
  Procedure.l FindNearest(Color.l)
    ; Find the nearest color
    Protected.l c, c0, c1, d, bestd = $12000000
    Protected.Long *p0, *p1
    !movzx eax, byte [p.v_Color + 1]
    !mov [p.v_d], eax
    *p1 = @Palette(IndexG(d)) : *p0 = *p1 - 4
    c0 = *p0\l : c1 = *p1\l
    M_FindNearest(0, -4)
    M_FindNearest(1, 4)
    ProcedureReturn c
  EndProcedure
  
  Macro M_DitherImage(offset, n = 1)
    !movsx ecx, byte [p.v_err + offset]
    !movsx eax, byte [p.v_err50 + offset]
    !add ecx, eax
    !imul ecx, edx
    !sar ecx, 8
    !movzx eax, byte [p.v_c0 + offset]
    !add eax, [p.v_badd]
    !imul eax, [p.v_cmul]
    !sar eax, 8
    !lea eax, [eax + ecx + 128]
    !neg ah
    !setz cl
    !neg cl
    !and al, cl
    !sar ah, 7
    !or al, ah
    !mov [p.v_c0 + offset], al
  EndMacro
  
  Procedure.i DitheredImage(Image.i, DitherLevel.a = 220, Brightness.b = 0, Contrast.b = 0, ProgressCallback.ProtoProgressCallback = 0)
    ; Return a dithered image
    ; DitherLevel : 0 - 255
    ; Brightness : -128 - 127
    ; Contrast : -128 - 127
    Protected.i result, x, y, w, h
    Protected.l c0, c1, badd, cmul, err50, err
    If ProgressCallback : ProgressCallback(0) : EndIf
    result = CopyImage(Image, #PB_Any)
    If result And StartDrawing(ImageOutput(result))
      h = OutputHeight()
      w = OutputWidth()
      If DitherLevel = 0 And Brightness = 0 And Contrast = 0
        While y < h
          x = 0
          While x < w
            Plot(x, y, FindNearest(Point(x, y)))
            x + 1
          Wend
          y + 1
          If ProgressCallback
            ProgressCallback(100 * y / h)
          EndIf
        Wend
      Else
        badd = Brightness - 128
        cmul = (33280 * Contrast + 4259840) / (16640 - Contrast << 7)
        Dim d_error.l(w)
        While y < h
          x = 0 : err50 = 0
          While x < w
            c0 = Point(x, y)
            ; add previous error
            err = d_error(x)
            !movzx edx, byte [p.v_DitherLevel]
            M_DitherImage(0)
            M_DitherImage(1)
            M_DitherImage(2)
            c1 = FindNearest(c0)
            Plot(x, y, c1)
            ; calculate 50% error
            !mov eax, [p.v_c0]
            !mov ecx, [p.v_c1]
            !mov edx, eax
            !not edx
            !and edx, ecx
            !and edx, 0x01010101
            !or eax, 0x01010101
            !and ecx, 0xfefefefe
            !sub eax, ecx
            !xor eax, 0x01010101
            !shr eax, 1
            !sub eax, edx
            !mov ecx, [p.v_err50]
            !mov [p.v_err50], eax
            ; mix with previous error
            !xor eax, 0x80808080
            !xor ecx, 0x80808080
            !mov edx, eax
            !and edx, ecx
            !and edx, 0x01010101
            !and eax, 0xfefefefe
            !and ecx, 0xfefefefe
            !add eax, ecx
            !shr eax, 1
            !add eax, edx
            !xor eax, 0x80808080
            !mov [p.v_err], eax
            d_error(x) = err
            x + 1
          Wend
          d_error(0) << 1
          y + 1
          If ProgressCallback
            ProgressCallback(100 * y / h)
          EndIf
        Wend
      EndIf
      StopDrawing()
    EndIf
    ProcedureReturn result
  EndProcedure
  
  DisableASM
  
  DataSection
    CGAPalette:
    Data.l $000000, $AA0000, $00AA00, $AAAA00, $0000AA, $AA00AA, $0055AA, $AAAAAA
    Data.l $555555, $FF5555, $55FF55, $FFFF55, $5555FF, $FF55FF, $55FFFF, $FFFFFF
  EndDataSection
  
  ; Set default palette
  CatchPalette(?CGAPalette, 16)
  
EndModule
;}


; читаем файл с палитрами.
If ReadFile(#File, "pal.bin")
  
  ; первая палитра
  pal = 1
  For colornumindex = 0 To 15
    ; по 2 байта на bgr цвет
    ; в первом из двух лежит только один сегмент - blue - b
    b    = ReadAsciiCharacter(#File)
    ; во втором байте два цвета green и red - g и r
    temp = ReadAsciiCharacter(#File)
    g    = temp >> 4 ; наш любимый сдвиг. здесь на 4 бита вправо и это превратит число $12 в $1
    r    = temp & $F
    ; теперь подготавливаем код цвета GRB 
    NormalRGBColor.l = RGB(SegaSegmentColor(r), SegaSegmentColor(g), SegaSegmentColor(b))
    ; и вносим его в нужную ячейку таблицы
    PalNum(pal)\ColorNum[colornumindex] = NormalRGBColor
  Next
  
  ; вторая палитра
  pal = 2
  For colornumindex = 0 To 15
    ; по 2 байта на bgr цвет
    ; в первом из двух лежит только один сегмент - blue - b
    b    = ReadAsciiCharacter(#File)
    ; во втором байте два цвета green и red - g и r
    temp = ReadAsciiCharacter(#File)
    g    = temp >> 4 ; наш любимый сдвиг. здесь на 4 бита вправо и это превратит число $12 в $1
    r    = temp & $F
    ; теперь подготавливаем код цвета GRB 
    NormalRGBColor.l = RGB(SegaSegmentColor(r), SegaSegmentColor(g), SegaSegmentColor(b))
    ; и вносим его в нужную ячейку таблицы
    PalNum(pal)\ColorNum[colornumindex] = NormalRGBColor
  Next
  
  ; третья палитра
  pal = 3
  For colornumindex = 0 To 15
    ; по 2 байта на bgr цвет
    ; в первом из двух лежит только один сегмент - blue - b
    b    = ReadAsciiCharacter(#File)
    ; во втором байте два цвета green и red - g и r
    temp = ReadAsciiCharacter(#File)
    g    = temp >> 4 ; наш любимый сдвиг. здесь на 4 бита вправо и это превратит число $12 в $1
    r    = temp & $F
    ; теперь подготавливаем код цвета GRB 
    NormalRGBColor.l = RGB(SegaSegmentColor(r), SegaSegmentColor(g), SegaSegmentColor(b))
    ; и вносим его в нужную ячейку таблицы
    PalNum(pal)\ColorNum[colornumindex] = NormalRGBColor
  Next
  
  ; четвертая палитра
  pal = 4
  For colornumindex = 0 To 15
    ; по 2 байта на bgr цвет
    ; в первом из двух лежит только один сегмент - blue - b
    b    = ReadAsciiCharacter(#File)
    ; во втором байте два цвета green и red - g и r
    temp = ReadAsciiCharacter(#File)
    g    = temp >> 4 ; наш любимый сдвиг. здесь на 4 бита вправо и это превратит число $12 в $1
    r    = temp & $F
    ; теперь подготавливаем код цвета GRB 
    NormalRGBColor.l = RGB(SegaSegmentColor(r), SegaSegmentColor(g), SegaSegmentColor(b))
    ; и вносим его в нужную ячейку таблицы
    PalNum(pal)\ColorNum[colornumindex] = NormalRGBColor
  Next
  
  CloseFile(#File)
EndIf

; создаем само изображение, пока пустое. это будет черный длинный прямоугольник
CreateImage(#SamaKartinka, 320, 80)
; создаем изображение для сеговских цветов
CreateImage(#VstavkinaKartinkaSega, 32, 32)

; стартуем сам процесс рисования
; ставим вывод, что рисовать в картинку
If StartDrawing(ImageOutput(#SamaKartinka))
    
  ; сначала черный фон на всю картинку
  Box(0, 0, 320, 80, RGB(0, 0, 0)) ; это черный цвет. в принципе можно было просто 0 написать вместо RGB(0, 0, 0)
  
  y = 0 ; первая палитра начнет рисоваться с самого верха 
  ; стартанем цикл в цикле с перебором всех ячеек в нашем массиве палитр
  For Pal = 1 To 4
    ; гоняем все 4 палитры
    
    ; на входе в цвета сбрасываем координату Х на начало картинки
    x = 0
    For ColorNumIndex = 0 To 15
      ; гоняем все цвета в конкретной палитре
      
      Box(x, y, 20, 20, PalNum(Pal)\ColorNum[ColorNumIndex])
      
      ; сдвигаем координату вправо для следующего цвета
      x + 20 
    Next
    ; когда достигли последнего 16 цвета в палитре - сдвигаем координату на одну строчку ниже
    y + 20
  Next
  
  ; остановка рисования
  StopDrawing()
EndIf

; прочитаем в память файл иконки
If ReadFile(#File, "01.bin")
  
  ; получаем размер файла
  length = Lof(#File)
  
  ; резервируем память нужного размера под файл
  *MemoryID = AllocateMemory(length)         ; allocate the needed memory
  
  If *MemoryID
    ; если память зарезервировалась
    
    ; читаем из файла в эту память
    ReadData(#File, *MemoryID, length)   ; read all data into the memory block
    
  Else
    ; а могла память и не зарезервироваться. мало ли какой глюк.
    MessageRequester("ошибка", "во время работы с памятью возникли проблемы.")
  EndIf  
  
  ; закрываем файл
  CloseFile(#File)
EndIf

; главное окно программы
If OpenWindow(#Window, 100, 100, 340, 160, "Якубович под грибами играет в Сегу", #PB_Window_MinimizeGadget | #PB_Window_ScreenCentered)
  
  ; добавляем гаджет-картинку, с подготовленным изображением
  ImageGadget(#GadgetKartinka, 10, 10, 320, 80, ImageID(#SamaKartinka))
  
  ; добавлем гаджет-канвас, куда будем рисовать графику из файла 01.bin
  CanvasGadget(#Canvas, 40, 110, 32, 32)  
  
  ; стартуем рисование картинки на гаджете-канвасе
  If StartDrawing(CanvasOutput(#Canvas))
    
    ; рисуем первый тайл в 0:0 координатах
    RisuemTile(0,  0, *MemoryID)
    
    ; рисуем второй тайл. он получается 0:8 и считаем память для следующего тайла то есть + 32 байта.
    RisuemTile(0,  8, *MemoryID + 32)
    
    ; третий тайл, и так далее
    RisuemTile(0, 16, *MemoryID + 64)
    RisuemTile(0, 24, *MemoryID + 96)
    
    RisuemTile(8,  0, *MemoryID + 128)
    RisuemTile(8,  8, *MemoryID + 160)
    RisuemTile(8, 16, *MemoryID + 192)
    RisuemTile(8, 24, *MemoryID + 224)
    
    RisuemTile(16,  0, *MemoryID + 256)
    RisuemTile(16,  8, *MemoryID + 288)
    RisuemTile(16, 16, *MemoryID + 320)
    RisuemTile(16, 24, *MemoryID + 352)
    
    RisuemTile(24,  0, *MemoryID + 384)
    RisuemTile(24,  8, *MemoryID + 416)
    RisuemTile(24, 16, *MemoryID + 448)
    RisuemTile(24, 24, *MemoryID + 480)
    
    ; остановка рисования
    StopDrawing()
  EndIf
  
  ; канвас для рисования картинки для вставки
  CanvasGadget(#Canvas2, 120, 110, 32, 32) 
  ; кнопка для вставки
  ButtonGadget(#Vstavka, 160, 110, 100, 32, "вставить и перегнать", #PB_Button_MultiLine)
  
  ; канвас с уже сеговскими цветами из палитры
  CanvasGadget(#Canvas3, 270, 110, 32, 32) 
  
  ; бесконечный цикл обработки событий на окне
  Repeat
    
    ; разбор где именно происходит событие
    Select WaitWindowEvent()

      Case #PB_Event_Gadget
        ; это было событие на каком-то гаджете
        
        ; проверяем какой именно гаджет это был
        Select EventGadget()
            
          Case #Vstavka
            ; ага! это была кнопка!
            
            If EventType() = #PB_EventType_LeftClick
              ; если событие на кнопке это левый клик мышкой, то...
              
              ; сначала освобождаем, но только в случае если картинка существует.
              If IsImage(#VstavkinaKartinka)                
                FreeImage(#VstavkinaKartinka)                
              EndIf
              
              ; проверка - сидит ли в буфере обмена картинка?
              If GetClipboardImage(#VstavkinaKartinka)
                ; да, все в порядке и картинка там есть
                
                ; проверить на размеры
                If ImageWidth(#VstavkinaKartinka) = 32 And ImageHeight(#VstavkinaKartinka) = 32
                  ; все в порядке и размеры совпадают 32х32
                  
                  ; выставляем в канвас вставки наше изображение
                  SetGadgetAttribute(#Canvas2, #PB_Canvas_Image, ImageID(#VstavkinaKartinka))
                  
                  
                  ;{ главная магия
                  
                  ; сначала загон палитры в модуль подбора цветов
                  NearestColor::CatchPalette(@PalNum(2)\ColorNum, 16)
                  
                  ; рисуем выводное изображение с сеговскими цветами
                  If StartDrawing(ImageOutput(#VstavkinaKartinkaSega))
                    
                    ; рисуем полностью 24 битное изображение, что было получено из буфера обмена
                    DrawImage(ImageID(#VstavkinaKartinka), 0, 0)
                    
                    ; стартуем прогон попиксельно
                    For x = 0 To 31
                      For y = 0 To 31
                        
                        ; читаем номер цвета в пикселе
                        original24bcolor = Point(x, y)
                        
                        ; подбираем похожий цвет из нашей сеговской палитры
                        segacolor        = NearestColor::FindNearest(original24bcolor)
                        
                        ; перерисовываем данную точку новым - сеговским кошерным цветом
                        Plot(x, y, segacolor)
                        
                      Next
                    Next
                    
                    StopDrawing()
                  EndIf
                  
                  ; выставляем в канвас сеговской картинки наше перерисованное изображение
                  SetGadgetAttribute(#Canvas3, #PB_Canvas_Image, ImageID(#VstavkinaKartinkaSega))
                  
                  ;}
                  
                  
                Else
                  ; размеры несовпадают
                  MessageRequester("ашипка", "в буфере обмена изображение хоть и есть, но не соответствует размеру 32х32 пикселя.")
                EndIf

              Else
                ; нет. в буфере может быть текст или он пустой или еще чего... но не картинка.
                MessageRequester("ашипка", "в буфере обмена нет изображения для вставки.")
              EndIf
              
            EndIf

        EndSelect

      Case #PB_Event_CloseWindow
        ; событие закрытия окна
        qiut = 1
   
    EndSelect
    
  ; крутить бесконечно, пока переменная qiut не будет равна 1. то есть пока не будет нажат крестик на окне.
  Until qiut = 1

EndIf

End



; IDE Options = PureBasic 6.00 LTS (Windows - x86)
; CursorPosition = 622
; FirstLine = 318
; Folding = hA9
; EnableXP
; DPIAware